> For the complete documentation index, see [llms.txt](https://docs.ngsurvey.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ngsurvey.com/form-management/tasks/task-items/webhook/webhooks-payload-transform.md).

# Webhooks payload transform

## 🔃 What is the Webhooks payload transform for ?

Not all APIs that should receive the payload of the respondent answers are the same as such you can use the transform template to transform the original JSON payload of the respondent answers into another custom formatted JSON of your choice to match perfectly any third party API specifications

Below a simple example that reformats the original payload properties names with new custom names and creates a hierarchical representation of the respondent and his answers. Its of course possible to completely re-transform the original JSON payload to any type of JSON structure.

```
{
    "myCustomRespondent": {
    "id": "#valueof($.respondent.id)",
    "surveyId": "#valueof($.respondent.surveyId)",
    "panelistId": "#valueof($.respondent.panelistId)",
    "contextUsername": "#valueof($.respondent.contextUsername)",
    "resumeUId": "#valueof($.respondent.resumeUId)",
    "resumePageId": "#valueof($.respondent.resumePageId)",
    "startDate": "#valueof($.respondent.startDate)",
    "voteDate": "#valueof($.respondent.voteDate)",
    "iPSource": "#valueof($.respondent.iPSource)",
    "changeUID": "#valueof($.respondent.changeUID)",
    "progressSaveDate": "#valueof($.respondent.progressSaveDate)",
    "languageCode": "#valueof($.respondent.languageCode)",
    "timeToEnd": "#valueof($.respondent.timeToEnd)",
    "validated": "#valueof($.respondent.validated)",
    "myQuerystring": "#valueof($.querystring)",
    "myCustomAnswers":{
      "#loop($.answers)": {
        "respondentId": "#currentvalueatpath($.respondentId)",
        "value":"#currentvalueatpath($.value)",
        "answerId": "#currentvalueatpath($.answerId)",
        "answerText": "#currentvalueatpath($.answerText)",
        "questionId": "#currentvalueatpath($.questionId)",
        "questionAlias": "#currentvalueatpath($.questionAlias)",
        "questionText": "#currentvalueatpath($.questionText)",
        "sectionNumber": "#currentvalueatpath($.sectionNumber)"
      }
    },
      "myCustomDataAttributes":{
      "#loop($.dataAttributes)": {
        "securityItemId": "#currentvalueatpath($.securityItemId)",
        "respondentId":"#currentvalueatpath($.respondentId)",
        "attributeName": "#currentvalueatpath($.attributeName)",
        "attributeValue": "#currentvalueatpath($.attributeValue)"
      }
    },
      "myVisitedPages":{
      "#loop($.visitedPages)": {
        "id": "#currentvalueatpath($.id)",
        "respondentId":"#currentvalueatpath($.respondentId)",
        "visitTime": "#currentvalueatpath($.visitTime)"
      }
    }
  }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.ngsurvey.com/form-management/tasks/task-items/webhook/webhooks-payload-transform.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
